@echo off
REM
REM BEGIN COPYRIGHT
REM *************************************************************************
REM Licensed Materials - Property of IBM 
REM 5724-L01, 5655-N53, 5724-I82, 5655-R15
REM (C) Copyright IBM Corporation 2006. All rights reserved. 
REM US Government Users Restricted Rights - Use, duplication, or disclosure
REM restricted by GSA ADP Schedule Contract with IBM Corp.
REM *************************************************************************
REM END COPYRIGHT
   
REM --------------------------------------------------------------------------
REM Description:   Executes the db2cmd configCommonDB.bat scripts to create
REM the CommonDB database.
REM
REM Usage: 
REM  configCommonDB.bat [createDB]
REM
REM Parameters:
REM 	createDB    - specify whether or not  to create a new db 
REM
REM Example:
REM 	configCommonDB.bat  createDB   //create a new db
REM 	configCommonDB.bat                    // use an existing db
REM     
REM
REM Return Codes:  0 for success
REM --------------------------------------------------------------------------

setlocal

%~d0
cd %~p0

set DB_CREATE=%1

REM ==========================================
REM DB_NAME will be replaced 
REM ==========================================
set DB_NAME=#DB_NAME#

REM ==========================================
REM DB_USER will be replaced 
REM ==========================================
set DB_USER=#DB_USER#


:INPUT_USERNAME
if "%DB_USER%"==""  (
  set /p DB_USER=Please enter username: 
  goto INPUT_USERNAME
)



db2cmd /w /c /i .\createDBTables.bat %DB_USER% %DB_NAME% %DB_CREATE% 

if not %ERRORLEVEL%==0 (
    goto PRINT_USAGE
) else (
    goto END 
)

:PRINT_USAGE

REM Print usage messages
echo.
echo ================================================================
echo Usage: configCommonDB.bat [createDB]
echo.
echo Parameters:
echo    createDB    - specify whether or not to  create a new db 
echo ================================================================

goto END

:END

endlocal
