@echo off
REM BEGIN COPYRIGHT
REM *************************************************************************
REM Licensed Materials - Property of IBM 
REM 5724-L01, 5655-N53, 5724-I82, 5655-R15
REM (C) Copyright IBM Corporation 2006. All rights reserved. 
REM US Government Users Restricted Rights - Use, duplication, or disclosure
REM restricted by GSA ADP Schedule Contract with IBM Corp.
REM *************************************************************************
REM END COPYRIGHT

setlocal

set PRODUCT_VERSION=%1
set DB_NAME=%2
set DB_USER=%3

REM --  CONNECT TO THE EXISTING DATABASE FOR COMMONDB UPDATES

@db2 connect to %DB_NAME% USER %DB_USER% %USING%

set RC=%ERRORLEVEL%
if not %RC%==0 goto PRINT_USAGE

@db2 set current schema=%DB_USER%

dir /B | findstr "upgradeSchema%PRODUCT_VERSION%_" > %PRODUCT_VERSION%.log

for /F "tokens=1* delims=" %%v in ( %PRODUCT_VERSION%.log ) do (
       @db2 -s -t -f ".\%%v"
       if not %RC%==0 goto PRINT_USAGE
)

goto END 

:PRINT_USAGE

REM Print usage messages


echo =====================================================================================
echo username/password/dbname is wrong. Please re-enter correct username/password/dbName
echo =====================================================================================
echo Usage: upgradeSchema.bat ^<product_version^>  ^<dbName^> ^<dbuser^>
echo
echo Parameters:
echo product_version   -  Specify the migration version ie., 602 or 610 or 612 
echo dbname	           -  DB2 Database Name(dbName) ie., WPRCSDB 
echo dbuser            -  User who can execute common scripts ie.,dbUserId
echo
echo Examples:
echo         1. upgradeSchema.bat
echo         2. upgradeSchema.bat 602 WPRCSDB dbUserId 
echo =====================================================================================

goto END

:END

rem del  %PRODUCT_VERSION%.log

endlocal