"""
	Licensed Materials - Property of IBM Corp. 
IBM Rational Automation Framework 
(c) Copyright IBM Corporation 2003, 2012. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: updateAutoStart.py
	
	Script which sets whether an application deployed to WAS will start automatically when the server is (re)started
"""

from com.ibm.rational.rafw.wsadmin.logging import MessageManager
import sys


def updateAutoStart(appName, autoStart):
	
		# read available installable apps
		global AdminApp
		global AdminConfig
		
		appExists = WasDeploy.checkIfAppExists(appName)
		if (appExists):
			application = AdminConfig.getid("/Deployment:"+appName+"/" ).strip()
			appObjectRef = AdminConfig.showAttribute(application, 'deployedObject')
			mappings = AdminConfig.showAttribute(appObjectRef, 'targetMappings')
			arrayMappings = mappings[1:len(mappings)-1].split(" ")
			logger.log("CRWWA2000I", [appName,autoStart])
			for mapping in arrayMappings:
				AdminConfig.modify(mapping, [['enable', autoStart]])
		else:
			raise MessageManager.getExceptionMessage(MessageManager.RB_WEBSPHERE_WAS, "CRWWA2001E", [appName])
		#endIf
#endDef 

appName = sys.argv[0]
optDict, args = SystemUtils.getopt( sys.argv, 'appProps:' )
logger = _Logger("updateAutoStart", MessageManager.RB_WEBSPHERE_WAS)
# parse the properties into props
props = SystemUtils.getPropertyDict( optDict['appProps'] )
if (props.has_key("AUTO_START")):
	autoStart = props["AUTO_START"]
	updateAutoStart(appName, autoStart)
	AdminHelper.saveAndSyncCell()
else:
	raise MessageManager.getExceptionMessage(MessageManager.RB_WEBSPHERE_WAS, "CRWWA2002E", [appName, optDict['appProps']])
#endIf