"""
	Licensed Materials - Property of IBM Corp. 
IBM Rational Automation Framework 
(c) Copyright IBM Corporation 2003, 2012. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: nodeagentUpdatePorts.py
	
	TODO: description
"""


from org.python import modules
from sys import argv
from java.util import Properties
from java.util import Hashtable
from java.io import FileInputStream

arglen=len(sys.argv)
num_exp_args=1 
usage="[fully qualified path of  property file]"  
if (arglen != num_exp_args):
	raise "Usage: %s" % (usage)

#Read properties file.
propFile=argv[0]
properties=Properties();

try:
	properties.load(FileInputStream(propFile))
	print "Succesfully read property file %s" % (propFile)
except:
	raise "Cannot read property file %s" % (propFile)

#an array of the needed port keys
portKeyArray=["NODEAGENT_BOOTSTRAP", "NODEAGENT_CSIV2_SSL_MUTUALAUTH_LISTENER_ADDRESS", "NODEAGENT_CSIV2_SSL_SERVERAUTH_LISTENER_ADDRESS", "NODEAGENT_DRS_CLIENT_ADDRESS", "NODEAGENT_NODE_DISCOVERY_ADDRESS", "NODEAGENT_NODE_MULTICAST_DISCOVERY_ADDRESS", "NODEAGENT_ORB_LISTENER_ADDRESS", "NODREAGENT_SAS_SSL_SERVERAUTH_LISTENER_ADDRESS", "NODEAGENT_SOAP_CONNECTOR"]

#Load in needed port values into a hash table
myHashtable=Hashtable()
try:
	portKey=""
	for i in range(len(portKeyArray)):
		portKey=portKeyArray[i]
		port=int(properties.getProperty(portKey))
		myHashtable.put(portKey,port)
		print "%s=%s" % (portKey,port)
except:
	raise "Cannot load valid port value for property key %s" % (portKey)

#Load in hostname
hostNameKey="HOST_NAME"
hostName=str(properties.getProperty(hostNameKey))
if (hostName=="None"):
	raise "Cannot find valid host name for key %s" % (hostNameKey)
else:
	print "%s=%s" % (hostNameKey,hostName)

#Load in nodeName
nodeNameKey="NODE_NAME"
nodeName=str(properties.getProperty(nodeNameKey))
if (nodeName=="None"):
	raise "Cannot find valid node name for key %s" % (nodeNameKey)
else:
	print "%s=%s" % (nodeNameKey,nodeName)

#get the id for the ndoeagent
cell = AdminConfig.list("Cell" )
cellName = AdminConfig.showAttribute(cell, "name" )
s=AdminConfig.getid("/Cell:"+cellName+"/Node:"+nodeName+"/Server:nodeagent/") 
 
# NODEAGENT PORTS
#update bootstrap address
myBoot=int(myHashtable.get("NODEAGENT_BOOTSTRAP"))
ns=AdminConfig.list('NameServer',s)
print 'Updating bootstrap address to %i' % (myBoot)
AdminConfig.modify(ns, [['BOOTSTRAP_ADDRESS', [['port', myBoot], ['host', hostName]]]])
 
#update csiv2 ssl serverauth listener address
myServerAuth=int(myHashtable.get("NODEAGENT_CSIV2_SSL_SERVERAUTH_LISTENER_ADDRESS"))
serverAuth = AdminConfig.list('', s)
print 'Updating csiv2 ssl serverauth listener address to %i' % (myServerAuth)
AdminConfig.modify(serverAuth, [['CSIV2_SSL_SERVERAUTH_LISTENER_ADDRESS'], [['host', hostName],  ['port', myServerAuth]]])

#update csiv2 ssl mutualauth listener address
myMutualAuth=int(myHashtable.get("NODEAGENT_CSIV2_SSL_MUTUALAUTH_LISTENER_ADDRESS"))
mutualAuth = AdminConfig.list('', s)
print 'Updating csiv2 ssl mutualauth listener address to %i' % (myMutualAuth)
AdminConfig.modify(mutualAuth, [['CSIV2_SSL_MUTUALAUTH_LISTENER_ADDRESS'], [['host', hostName],  ['port', myMutualAuth]]])

#update  drs client address
myDRS=int(myHashtable.get("NODEAGENT_DRS_CLIENT_ADDRESS"))
drs = AdminConfig.list('SystemMessageServer', s)
print 'Updating drs client address' % (myDRS)
AdminConfig.modify(drs, [['DRS_CLIENT_ADDRESS'], [['host', hostName], ['port', myDRS]]])
  
#update node discovery address   
myNodeDiscAddr=int(myHashtable.get("NODEAGENT_NODE_DISCOVERY_ADDRESS"))
nodeDiscAddr=AdminConfig.list('NodeAgent', s)
print 'Updating node discovery address' % (nodeDiscAddr)
AdminConfig.modify(nodeDiscAddr, [['DRS_CLIENT_ADDRESS'], [['host', hostName], ['port', myNodeDiscAddr]]])
  
#update node multicast discovery address   
myNodeMultiDiscAddr=int(myHashtable.get("NODEAGENT_NODE_MULTICAST_DISCOVERY_ADDRESS"))
nodeMultiDiscAddr=AdminConfig.list('', s)
print 'Updating node multicast discovery address' % (nodeMultiDiscAddr)
AdminConfig.modify(nodeMultiDiscAddr, [['NODE_MULTICAST_DISCOVERY_ADDRESS'], [['host', hostName], ['port', myNodeDiscAddr]]])

#update orb listener address
myOrbListenerAddress=int(myHashtable.get("NODEAGENT_ORB_LISTENER_ADDRESS"))
orbListenerAddress=AdminConfig.list('ObjectRequestBroker', s)
print 'Updating node multicast discovery address' % (orbListenerAddress)
AdminConfig.modify(orbListenerAddress, [['ORB_LISTENER_ADDRESS'], [['host', hostName], ['port', myOrbListenerAddress]]])

#update sas ssl serverauth listener address
mySasServerAuth=int(myHashtable.get("NODEAGENT_SAS_SSL_SERVERAUTH_LISTENER_ADDRESS"))
sasServerAuth = AdminConfig.list('', s)
print 'Updating sas ssl serverauth listener address to %i' % (mySasServerAuth)
AdminConfig.modify(sasServerAuth, [['SAS2_SSL_SERVERAUTH_LISTENER_ADDRESS'], [['host', hostName],  ['port', mySasServerAuth]]])

#update soap address
mySOAP=int(myHashtable.get("NODEAGENT_SOAP_CONNECTOR"))
soap = AdminConfig.list('SOAPConnector', s)
print 'Updating soap address to %i' % (mySOAP)
AdminConfig.modify(soap, [['SOAP_CONNECTOR'], [['host', hostName],  ['port', mySOAP]]])

AdminConfig.save()
