"""
	Licensed Materials - Property of IBM Corp. 
IBM Rational Automation Framework 
(c) Copyright IBM Corporation 2003, 2012. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: ConfigFileReader.py
	
	Encapsulates useful utilities used to read configuration files
"""

from XmlProperty import *
import sys

from com.ibm.rational.rafw.wsadmin.performance import Performance

############## CLASS :: _ConfigFileReader   ##############
# Encapsulates useful utilities used to                  #
# read configuration files.                              #
#                                                        #
##########################################################
class _ConfigFileReader:
	
	"""
	openXmlConfig(xmlFile)
	
	open the an xml file using the XmlProperty class
	"""
	def openXmlConfig(self, xmlFile):
		Performance.start("ConfigFileReader.openXmlConfig")
		try:
			xmlProp  = XmlProperty( xmlFile )
		except:
			print "ERROR: Unable to find or parse:" 
			print "   " + xmlFile
			print "Caused by: " + str(sys.exc_info()[1])
			raise "Unable to find or parse file: " + xmlFile
		#endTry
		Performance.end("ConfigFileReader.openXmlConfig")
		return xmlProp
	#endDef
	
#endClass

## define global singletons
ConfigFileReader = _ConfigFileReader()	

