"""
	Licensed Materials - Property of IBM Corp. 
IBM Rational Automation Framework 
(c) Copyright IBM Corporation 2003, 2012. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: Globals.py
	
	Contains Globals used by jython scripts in this system.
"""

import java
import java.lang.System as System
import os

"""
	The display text used when an attribute value is not specified
	in the RAFW XML file.
"""
ATTRIBUTE_VALUE_MISSING="None Supplied"

"""
	Constants for Read/Write WASKey is used in xml files to denote 
	the attribute key name was used for a child element
"""
WAS_KEY_ATTR_NAME = 'WASKey'
RAFW_TYPE ='RAFW_TYPE'
RAFW_TYPE_REFERENCE = "reference"
RAFW_PARENT_TYPE='PARENT_TYPE'
RAFW_PARENT_NAME='PARENT_NAME'

RAFW_XML_PREFIX = "RAFW_"

def getInstallRoot(): 
	rafwHome = System.getProperty("RAFW_HOME")
	if (rafwHome is None):
		print "ERROR: RAFW_HOME is not present in system properties, defaulting to /opt/RAFW"
		rafwHome = "/opt/RAFW"
	#endIf
	rafwHome = rafwHome.strip()
	return rafwHome
#endDef
