"""
	Licensed Materials - Property of IBM Corp. 
IBM Rational Automation Framework 
(c) Copyright IBM Corporation 2003, 2012. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: VelocityJythonLogger.py
	
	Logger used by Velocity in Jython scripts in the framework
	
	@deprecated: this is no longer used since the 7.1.2 release and the introduction
	of a logging infrastructure.
"""

import org
import org.apache.velocity.runtime.log.LogChute as LogChute
from Logger import _Logger
from com.ibm.rational.rafw.wsadmin.logging import MessageManager

"""
	Implements the Velocity Logging Interface so that Velocity based 
	Jython scripts can use the same logging facility when working with Velocity.
	
	This class is an adapter between the Jython Logger and the Velocity LogChute
"""
class VelocityJythonLogger(LogChute):

	def __init__(self, logName = "Velocity"):
		self.LOGGER = _Logger(logName)
	#endDef
	
	def init(self, runtimeServices):
		pass
	#endDef

	def isLevelEnabled(self, level):
		if (level == LogChute.TRACE_ID):
			return self.LOGGER.isTraceEnabled()
		elif (level == LogChute.DEBUG_ID):
			return self.LOGGER.isDebugEnabled()
		elif (level == LogChute.INFO_ID):
			return self.LOGGER.isInfoEnabled()
		elif (level == LogChute.WARN_ID):
			return self.LOGGER.isWarnEnabled()
		elif (level == LogChute.ERROR_ID):
			return self.LOGGER.isErrorEnabled()
		else:
			## unknown level, log it only if trace is enabled
			return self.LOGGER.isTraceEnabled()
		#endIf
	#endDef

	def log(self, level, message, throwable = None):
		if (throwable is None):
			msg = message
		else:
			msg = message + ":" + str(throwable)
		#endIf
		
		if (level == LogChute.TRACE_ID):
			self.LOGGER.trace(message)
		elif (level == LogChute.DEBUG_ID):
			self.LOGGER.debug(message)
		elif (level == LogChute.INFO_ID):
			self.LOGGER.info(message)
		elif (level == LogChute.WARN_ID):
			self.LOGGER.warn(message)
		elif (level == LogChute.ERROR_ID):
			self.LOGGER.error(message)
		else:
			## unknown level, log it to trace
			self.LOGGER.trace(message)
		#endIf
	#endDef

#endClass
	