"""
	Licensed Materials - Property of IBM Corp. 
IBM Rational Automation Framework 
(c) Copyright IBM Corporation 2003, 2012. All Rights Reserved.   

U.S. Government Users Restricted Rights - Use, duplication or disclosure restricted by 
GSA ADP Schedule Contract with IBM Corp. 

	
	File name: jythonLib.py
	
	Defines global modules used by the scripts and jython functions
	invoked in wsadmin by ant tasks.
"""

# Import declarations that are needed by scripts, these should be moved
# directly into the scripts that require them, but for now, they are all 
# defined here globally.
from    org.python.modules import re
from    java.io import StringReader
from    java.util import Properties
from    java.io import FileInputStream
from    java.io import FileOutputStream
from    java.io import PrintWriter
import  java.lang.System as Sys
import  sys
import  org.xml.sax as sax
import  org.apache.xerces.parsers.DOMParser as domparser
import  org.w3c.dom.traversal.NodeFilter as NodeFilter
import  org.w3c.dom.traversal as traversal
import  org.w3c.dom.Node as Node

import Globals
from Logger import _Logger
from com.ibm.rational.rafw.wsadmin.logging import MessageManager

# global constant used in some scripts
newline = Sys.getProperty("line.separator")

########################################################################
# In versions 6.0 and 6.1, these objects are not globally
# available in modules.  This allows us to access these
# objects directly in modules such as ConfigReader and ConfigWriter
#
# To use these objects in a module, add an import declaration near
# the top of the module.  For example:
#
#   import AdminConfig
#
########################################################################
try:
	if (AdminConfig is None or AdminTask is None or AdminApp is None or AdminControl is None):
		# raise a name error in case it hasn't already happened when we tried to test the above object states
		raise NameError
	else:
		sys.modules['AdminConfig'] = AdminConfig  
		sys.modules['AdminControl'] = AdminControl  
		sys.modules['AdminApp'] = AdminApp  
		sys.modules['AdminTask'] = AdminTask  
	#endIf
except NameError:
	raise MessageManager.getExceptionMessage(MessageManager.RB_WEBSPHERE_WAS, "CRWWA0146E", None)
#endTry

from com.ibm.rational.rafw.wsadmin.performance import Performance

Performance.start("load the singletons");
# Modules and singletons instances used by scripts.
# These singleton instances may also be used directly in ANT 
# when invoked using call_wsadmin_jython_function
from AdminHelper import *
from BFWCommand import *
from ConfigComparor import *
from ConfigFileReader import *
from ConfigFileWriter import *
from ConfigMediator import *
from ConfigReader import *
from ConfigWriter import ConfigWriter
from SystemUtils import *
from WasConfig import *
from WasDeploy import WasDeploy
from WpConfig import *
from XmlProperty import XmlProperty
Performance.end("load the singletons");

