-- The WSRR installer will replace the DBNAME, DBUSER and DB2TSDIR variables in this file

-- Licensed Materials - Property of IBM
-- 5724-N72 5655-R41
-- (c) Copyright IBM Corp. 2006, 2007 All Rights Reserved
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.

CREATE DATABASE @DBNAME@ ALIAS @DBNAME@ USING CODESET UTF-8 TERRITORY US COLLATE USING IDENTITY;


UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING APPLHEAPSZ      2048;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING APP_CTL_HEAP_SZ 2048;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING APPGROUP_MEM_SZ 13044;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING CATALOGCACHE_SZ 400;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING CHNGPGS_THRESH  60;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING DBHEAP          800;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOCKLIST        50;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOGBUFSZ        128;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOGFILSIZ       1000;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOGPRIMARY      50;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOGSECOND       200;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING MAXAPPLS        40;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING MAXLOCKS        77;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING MINCOMMIT       1;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING NUM_IOCLEANERS  1;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING NUM_IOSERVERS   3;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING PCKCACHESZ      859;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING SOFTMAX         80;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING SORTHEAP        1024;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING STMTHEAP        32768;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING DFT_DEGREE      1;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING DFT_PREFETCH_SZ 32;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING DFT_QUERYOPT    3;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING UTIL_HEAP_SZ    82299;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING AUTO_RUNSTATS ON AUTO_REORG ON AUTO_TBL_MAINT ON AUTO_MAINT ON;
UPDATE DATABASE MANAGER CONFIGURATION USING SHEAPTHRES         31195;
UPDATE DATABASE MANAGER CONFIGURATION USING INTRA_PARALLEL     ON;
UPDATE DATABASE MANAGER CONFIGURATION USING MAX_QUERYDEGREE    2;
UPDATE DATABASE MANAGER CONFIGURATION USING MAXAGENTS          400;
UPDATE DATABASE MANAGER CONFIGURATION USING NUM_POOLAGENTS     40;
UPDATE DATABASE MANAGER CONFIGURATION USING NUM_INITAGENTS     0;
UPDATE DATABASE MANAGER CONFIGURATION USING FCM_NUM_BUFFERS    4096;
UPDATE DATABASE MANAGER CONFIGURATION USING PRIV_MEM_THRESH    32767;
UPDATE DATABASE MANAGER CONFIGURATION USING agent_stack_sz     256;

CONNECT TO @DBNAME@;

ALTER BUFFERPOOL IBMDEFAULTBP SIZE 1024;

GRANT DBADM,CREATETAB,BINDADD,CONNECT,CREATE_NOT_FENCED_ROUTINE,IMPLICIT_SCHEMA,LOAD,CREATE_EXTERNAL_ROUTINE,QUIESCE_CONNECT ON DATABASE  TO USER @DBUSER@;

ALTER TABLESPACE USERSPACE1 PREFETCHSIZE 64;

CREATE BUFFERPOOL @DBNAME@ IMMEDIATE  SIZE 1000 PAGESIZE 32 K ;

CREATE BUFFERPOOL @DBNAME@TMP IMMEDIATE SIZE 1000 PAGESIZE 32 K; 

CREATE REGULAR TABLESPACE @DBNAME@DATA PAGESIZE 32 K  MANAGED BY SYSTEM  USING ('@DB2TSDIR@/@DBNAME@DATA' ) EXTENTSIZE 16 OVERHEAD 10.5 PREFETCHSIZE 16 TRANSFERRATE 0.14 BUFFERPOOL  @DBNAME@  DROPPED TABLE RECOVERY OFF;

CREATE REGULAR TABLESPACE @DBNAME@TS PAGESIZE 32 K  MANAGED BY SYSTEM  USING ('@DB2TSDIR@/@DBNAME@TS' ) EXTENTSIZE 16 OVERHEAD 10.5 PREFETCHSIZE 16 TRANSFERRATE 0.14 BUFFERPOOL  @DBNAME@  DROPPED TABLE RECOVERY OFF;

CREATE SYSTEM TEMPORARY TABLESPACE @DBNAME@TEMP PAGESIZE 32 K  MANAGED BY DATABASE  USING ( FILE '@DB2TSDIR@/@DBNAME@TEMP' 12800 ) EXTENTSIZE 64 OVERHEAD 10.5 PREFETCHSIZE 64 TRANSFERRATE 0.14 BUFFERPOOL  @DBNAME@TMP ;

CREATE REGULAR TABLESPACE @DBNAME@SCHED PAGESIZE 32 K MANAGED BY SYSTEM USING( '@DB2TSDIR@/@DBNAME@SCHED' ) EXTENTSIZE 16 OVERHEAD 10.5 PREFETCHSIZE 16 TRANSFERRATE 0.14 BUFFERPOOL  @DBNAME@  DROPPED TABLE RECOVERY OFF;

COMMENT ON TABLESPACE @DBNAME@DATA IS '32 page WSRR Data space';

COMMENT ON TABLESPACE @DBNAME@TEMP IS '32 page swap';

COMMENT ON TABLESPACE @DBNAME@TS IS '32 page WSRR TS Data space';

COMMENT ON TABLESPACE @DBNAME@SCHED IS '32 page WSRR Scheduler Data space';

COMMIT;
CONNECT RESET;
