-- ###############################################
-- WARNING
-- Do not perform any committable statements in this file
-- as they will be rolled back in the case where the user
-- drops the W_ tables and expects the system to bootstrap
-- the tables again but did not drop the sequences.  When
-- the CREATE SEQUENCE statements fail, the transation will
-- be rolled back along with any committable work.
-----------------------------------------------------------
----Create tables ,primary keys & indexes for  triplestore
-------------------------------------------------------------
 
 CREATE TABLE W_LIT_BOOL  (
		  ID INTEGER NOT NULL   , 
		  LITVAL SMALLINT )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_LIT_BOOL 
	ADD PRIMARY KEY
		(ID);



 CREATE TABLE W_LIT_DOUBLE  (
		  ID INTEGER NOT NULL , 
		  LITVAL DOUBLE )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_LIT_DOUBLE 
	ADD PRIMARY KEY
		(ID);



 CREATE TABLE W_LIT_FLOAT  (
		  ID INTEGER  NOT NULL , 
		  LITVAL REAL )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_LIT_FLOAT 
	ADD PRIMARY KEY
		(ID);



 CREATE TABLE W_LIT_INT  (
		  ID INTEGER NOT NULL  , 
		  LITVAL INTEGER )   
		 IN @DBNAME@TS ; 


ALTER TABLE W_LIT_INT 
	ADD PRIMARY KEY
		(ID);



 CREATE TABLE W_LIT_LONG  (
		  ID INTEGER NOT NULL , 
		  LITVAL BIGINT )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_LIT_LONG 
	ADD PRIMARY KEY
		(ID);



 CREATE TABLE W_NAMESPACE  (
		  ID INTEGER NOT NULL , 
		  NAMESPACE VARCHAR(254) NOT NULL )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_NAMESPACE 
	ADD PRIMARY KEY
		(ID);

CREATE UNIQUE INDEX IDX_NAMESPACE ON W_NAMESPACE 
		(NAMESPACE ASC) ;


 
 CREATE TABLE W_OBJ_LIT_ANY  (
		  ID INTEGER NOT NULL, 
		  LARGE LONG VARCHAR FOR BIT DATA , 
		  HASH VARCHAR(40) , 
		  TYPE_URI VARCHAR(254) NOT NULL )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_OBJ_LIT_ANY 
	ADD PRIMARY KEY
		(ID);



 CREATE TABLE W_OBJ_LIT_DATE  (
		  ID INTEGER NOT NULL , 
		  LITVAL TIMESTAMP )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_OBJ_LIT_DATE 
	ADD PRIMARY KEY
		(ID);


 
 CREATE TABLE W_OBJ_LIT_DATETIME  (
		  ID INTEGER NOT NULL , 
		  LITVAL TIMESTAMP )   
		 IN @DBNAME@TS ; 


ALTER TABLE W_OBJ_LIT_DATETIME 
	ADD PRIMARY KEY
		(ID);


 
 CREATE TABLE W_OBJ_LIT_STRING  (
		  ID INTEGER NOT NULL, 
		  LARGE LONG VARCHAR FOR BIT DATA , 
		  LITVAL VARCHAR(1024) , 
		  HASH VARCHAR(40) )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_OBJ_LIT_STRING 
	ADD PRIMARY KEY
		(ID);

 
 CREATE TABLE W_STATEMENT  (
		  ID INTEGER NOT NULL, 
		  VERSION_FROM INTEGER NOT NULL , 
		  VERSION_TO INTEGER NOT NULL , 
		  SUBJ_ID INTEGER NOT NULL , 
		  PRED_ID INTEGER NOT NULL , 
		  OBJ_ID INTEGER NOT NULL , 
		  OBJ_TYP_CD INTEGER NOT NULL )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_STATEMENT 
	ADD PRIMARY KEY
		(ID);



 CREATE TABLE W_URI  (
		  ID INTEGER NOT NULL , 
		  URI VARCHAR(254) NOT NULL , 
		  NAMESPACE_ID INTEGER NOT NULL )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_URI 
	ADD PRIMARY KEY
		(ID);

CREATE UNIQUE INDEX IDX_URI ON W_URI 
		(URI ASC) ;


CREATE TABLE W_OBJ_LIT_PLAIN (
                  ID  INTEGER  NOT NULL,
                  LARGE LONG VARCHAR FOR BIT DATA ,
                  LITVAL VARCHAR(1024) ,
                  HASH VARCHAR(40) ,
                  XML_LANG VARCHAR(64) )
                 IN @DBNAME@TS ;


ALTER TABLE W_OBJ_LIT_PLAIN
        ADD PRIMARY KEY
                (ID);


 
 CREATE TABLE W_VERSION  (
		  USERNAME VARCHAR(64) NOT NULL , 
		  CHANGE_TIME TIMESTAMP NOT NULL , 
		  CL_GID VARCHAR(36) , 
		  CL_LID VARCHAR(10) , 
		  SCHEMA_NS_ID INTEGER , 
		  SCHEMA_REV INTEGER , 
		  ID INTEGER NOT NULL )   
		 IN @DBNAME@TS ; 

ALTER TABLE W_VERSION 
	ADD PRIMARY KEY
		(ID);

CREATE TABLE W_DBVERSION  (
		  SUBSYSTEM VARCHAR(8) NOT NULL , 
		  CUR_VERSION INTEGER NOT NULL )   
		 IN @DBNAME@TS ;

ALTER TABLE W_DBVERSION 
	ADD PRIMARY KEY
		(SUBSYSTEM);
		
---------------------------------------------------------------------------------
-----Create Foreign keys on trplestore tables
---------------------------------------------------------------------------------

ALTER TABLE W_URI 
	ADD CONSTRAINT W_URI_FK_NAMESP FOREIGN KEY
		(NAMESPACE_ID)
	REFERENCES W_NAMESPACE
		(ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;


ALTER TABLE W_VERSION 
	ADD CONSTRAINT W_VER_FK_NAMESP FOREIGN KEY
		(SCHEMA_NS_ID)
	REFERENCES W_NAMESPACE
		(ID)
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

-- The CREATE SEQUENCE statements are at the bottom here so that
-- developers can drop their tables and have them recreated on restart
-- without having to drop sequences also.  This is because the DB2
-- Control Center does not provide a way to drop sequences.


CREATE SEQUENCE SEQ_W_LIT_BOOL_ID  
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_LIT_DOUBLE_ID 
 as integer START WITH 0 increment by 1
 no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_LIT_FLOAT_ID  
as integer START WITH 0 increment by 1
 no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_LIT_INT_ID  
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_LIT_LONG_ID  
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_NAMESPACE_ID
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_OBJ_LIT_ANY_ID  
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_OBJ_LIT_DATE_ID  
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_OBJ_LIT_DATETIME_ID 
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_OBJ_LIT_PLAIN_ID 
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_OBJ_LIT_STRING_ID  
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_STATEMENT_ID  
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;

CREATE SEQUENCE SEQ_W_URI_ID 
as integer START WITH 0 increment by 1
no  MAXVALUE  MINVALUE 1
NO CYCLE CACHE 20 ORDER ;




create index idx_smt_by_sbj on w_statement (subj_id);
create index idx_sbj_by_prp on w_statement (pred_id, obj_typ_cd, obj_id);
create index idx_sbj_by_val on w_statement (obj_typ_cd, obj_id);
create index idx_val_by_prp on w_statement (subj_id, pred_id);

create index idx_obj_dbl on w_lit_double (litval);

create index idx_obj_date on w_obj_lit_date (litval);

create index idx_obj_any on w_obj_lit_any (type_uri);

create index idx_obj_time on w_obj_lit_datetime (litval);

create index idx_obj_int on w_lit_int (litval);

create index idx_obj_str on w_obj_lit_string (hash);

create index idx_obj_plain on w_obj_lit_plain (hash);

create index idx_obj_long on w_lit_long (litval);

create index idx_obj_bool on w_lit_bool (litval);

create index idx_obj_flt on w_lit_float (litval);

-- create index idx_namespace on w_namespace (namespace);

-- create index idx_uri on w_uri (uri);
