-- Licensed Materials - Property of IBM
-- 5724-N72 5655-R41
-- (c) Copyright IBM Corp. 2009 All Rights Reserved
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.

CREATE TABLE SR_ACTIVITY_CONTAINER (
        ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY(START WITH 1,INCREMENT BY 1) ,
	TRANSACTION_ID VARCHAR (1020)  NOT NULL ,
	INSTANCE_ID VARCHAR (256) ,
	STATE VARCHAR (128)  NOT NULL ,
	VERSION INTEGER,
	TIME_CREATED TIMESTAMP  NOT NULL)
	IN @DBNAME@ACT ;

ALTER TABLE SR_ACTIVITY_CONTAINER ADD PRIMARY KEY (ID);

CREATE TABLE SR_ACTIVITY_APICALL (
	ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY(START WITH 1,INCREMENT BY 1),
	CONTAINER_ID INTEGER NOT NULL ,
        OWNING_APICALL_ID INTEGER,
	API_TYPE VARCHAR (8) ,
	METHOD VARCHAR (32) ,
	ROOT_OBJECT VARCHAR (64),
	USERID VARCHAR (64) ,
	TIME_CREATED TIMESTAMP NOT NULL)
	IN @DBNAME@ACT ;

ALTER TABLE SR_ACTIVITY_APICALL ADD PRIMARY KEY (ID);


CREATE TABLE SR_ACTIVITY_RECORD (
        ID INTEGER NOT NULL GENERATED ALWAYS AS IDENTITY(START WITH 1,INCREMENT BY 1),
	API_CALL_ID INTEGER NOT NULL,
	RESOURCE_ACTION VARCHAR (16) ,
	RESOURCE_TYPE VARCHAR (16) ,
	SUBJECT VARCHAR (1020) ,
	PREDICATE VARCHAR (1020),
	FROM_VALUE VARCHAR (1020) ,
	TO_VALUE VARCHAR (1020) ,
	TIME_CREATED TIMESTAMP NOT NULL)
	IN @DBNAME@ACT ;

ALTER TABLE SR_ACTIVITY_RECORD ADD PRIMARY KEY (ID);

GRANT SELECT,INSERT,UPDATE ON SR_ACTIVITY_CONTAINER TO USER @DBUSER@;
GRANT SELECT,INSERT,UPDATE ON SR_ACTIVITY_APICALL TO USER @DBUSER@;
GRANT SELECT,INSERT,UPDATE ON SR_ACTIVITY_RECORD TO USER @DBUSER@;
