-- The WSRR installer will replace the DBNAME, DBUSER and DB2TSDIR variables in this file

-- Licensed Materials - Property of IBM
-- 5724-N72 5655-R41
-- (c) Copyright IBM Corp. 2006, 2007 All Rights Reserved
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with
-- IBM Corp.

CREATE DATABASE @DBNAME@ ALIAS @DBNAME@ USING CODESET UTF-8 TERRITORY US COLLATE USING IDENTITY;

UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING STMTHEAP        32768;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING APPLHEAPSZ      8192;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING DBHEAP          65536;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOGBUFSZ        2048;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOGFILSIZ       1000;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOGPRIMARY      50;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOGSECOND       200;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING APP_CTL_HEAP_SZ 2048;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING APPGROUP_MEM_SZ 13044;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING CATALOGCACHE_SZ 400;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING CHNGPGS_THRESH  60;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOCKTIMEOUT     30;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING MAXLOCKS        100;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING LOCKLIST        3200;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING MAXAPPLS        40;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING MINCOMMIT       1;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING NUM_IOCLEANERS  1;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING NUM_IOSERVERS   3;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING PCKCACHESZ      859;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING SOFTMAX         80;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING SORTHEAP        1024;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING DFT_DEGREE      1;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING DFT_PREFETCH_SZ 32;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING DFT_QUERYOPT    3;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING UTIL_HEAP_SZ    82299;
UPDATE DATABASE CONFIGURATION FOR @DBNAME@ USING AUTO_RUNSTATS ON AUTO_REORG ON AUTO_TBL_MAINT ON AUTO_MAINT ON;

UPDATE DATABASE MANAGER CONFIGURATION USING agent_stack_sz     256;
UPDATE DATABASE MANAGER CONFIGURATION USING SHEAPTHRES         31195;
UPDATE DATABASE MANAGER CONFIGURATION USING INTRA_PARALLEL     ON;
UPDATE DATABASE MANAGER CONFIGURATION USING MAX_QUERYDEGREE    2;
UPDATE DATABASE MANAGER CONFIGURATION USING MAXAGENTS          400;
UPDATE DATABASE MANAGER CONFIGURATION USING NUM_POOLAGENTS     40;
UPDATE DATABASE MANAGER CONFIGURATION USING NUM_INITAGENTS     0;
UPDATE DATABASE MANAGER CONFIGURATION USING FCM_NUM_BUFFERS    4096;
UPDATE DATABASE MANAGER CONFIGURATION USING PRIV_MEM_THRESH    32767;

CONNECT TO @DBNAME@;

ALTER TABLESPACE USERSPACE1 PREFETCHSIZE 64;

CREATE BUFFERPOOL @DBNAME@TS IMMEDIATE SIZE 10000 PAGESIZE 4 K;

CREATE BUFFERPOOL @DBNAME@SCHED IMMEDIATE SIZE 500 PAGESIZE 32 K;

CREATE REGULAR TABLESPACE @DBNAME@TS PAGESIZE 4 K  MANAGED BY SYSTEM  USING ('@DB2TSDIR@/@DBNAME@TS' ) EXTENTSIZE 16 OVERHEAD 10.5 PREFETCHSIZE 16 TRANSFERRATE 0.14 BUFFERPOOL @DBNAME@TS  DROPPED TABLE RECOVERY OFF;

CREATE REGULAR TABLESPACE @DBNAME@SCHED PAGESIZE 32 K MANAGED BY SYSTEM USING( '@DB2TSDIR@/@DBNAME@SCHED' ) EXTENTSIZE 16 OVERHEAD 10.5 PREFETCHSIZE 16 TRANSFERRATE 0.14 BUFFERPOOL @DBNAME@SCHED DROPPED TABLE RECOVERY OFF;

COMMENT ON TABLESPACE @DBNAME@TS IS '4 page WSRR TS Data space';

COMMENT ON TABLESPACE @DBNAME@SCHED IS '32 page WSRR Scheduler Data space';

COMMIT;
CONNECT RESET;
TERMINATE;
